import { Component, Directive, Input, Output, HostListener, HostBinding, EventEmitter, ViewChild, ElementRef } from "@angular/core";
import { customValueAccessorFactory, CustomValueAccessor } from "../../../misc/util";
var SuiCheckbox = (function () {
    function SuiCheckbox() {
        this.isChecked = false;
        this.checkChange = new EventEmitter();
        this.isDisabled = false;
        this.isReadonly = false;
        this._checkboxClasses = true;
    }
    Object.defineProperty(SuiCheckbox.prototype, "checkedAttribute", {
        get: function () {
            return this.isChecked ? "" : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SuiCheckbox.prototype, "isDisabledAttribute", {
        get: function () {
            return this.isDisabled ? "disabled" : undefined;
        },
        enumerable: true,
        configurable: true
    });
    SuiCheckbox.prototype.onClick = function () {
        if (!this.isDisabled && !this.isReadonly) {
            this.toggle();
            this.focusCheckbox();
        }
    };
    SuiCheckbox.prototype.toggle = function () {
        this.isChecked = !this.isChecked;
        this.checkChange.emit(this.isChecked);
    };
    SuiCheckbox.prototype.writeValue = function (value) {
        this.isChecked = value;
    };
    SuiCheckbox.prototype.focusCheckbox = function () {
        this._checkboxElement.nativeElement.focus();
    };
    return SuiCheckbox;
}());
__decorate([
    HostBinding("class.ui"),
    HostBinding("class.checkbox"),
    __metadata("design:type", Boolean)
], SuiCheckbox.prototype, "_checkboxClasses", void 0);
__decorate([
    Input(),
    __metadata("design:type", String)
], SuiCheckbox.prototype, "name", void 0);
__decorate([
    HostBinding("class.checked"),
    __metadata("design:type", Boolean)
], SuiCheckbox.prototype, "isChecked", void 0);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter)
], SuiCheckbox.prototype, "checkChange", void 0);
__decorate([
    Input(),
    __metadata("design:type", Boolean)
], SuiCheckbox.prototype, "isDisabled", void 0);
__decorate([
    HostBinding("class.read-only"),
    Input(),
    __metadata("design:type", Boolean)
], SuiCheckbox.prototype, "isReadonly", void 0);
__decorate([
    ViewChild("checkbox"),
    __metadata("design:type", ElementRef)
], SuiCheckbox.prototype, "_checkboxElement", void 0);
__decorate([
    HostListener("click"),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], SuiCheckbox.prototype, "onClick", null);
SuiCheckbox = __decorate([
    Component({
        selector: "sui-checkbox",
        exportAs: "suiCheckbox",
        template: "\n<input class=\"hidden\"\n       type=\"checkbox\"\n       [attr.name]=\"name\"\n       [attr.checked]=\"checkedAttribute\"\n       [attr.disabled]=\"isDisabledAttribute\"\n       [(ngModel)]=\"isChecked\"\n       #checkbox>\n<label>\n    <ng-content></ng-content>\n</label>\n"
    }),
    __metadata("design:paramtypes", [])
], SuiCheckbox);
export { SuiCheckbox };
var SuiCheckboxValueAccessor = SuiCheckboxValueAccessor_1 = (function (_super) {
    __extends(SuiCheckboxValueAccessor, _super);
    function SuiCheckboxValueAccessor(host) {
        return _super.call(this, host) || this;
    }
    return SuiCheckboxValueAccessor;
}(CustomValueAccessor));
SuiCheckboxValueAccessor = SuiCheckboxValueAccessor_1 = __decorate([
    Directive({
        selector: "sui-checkbox",
        host: { "(checkChange)": "onChange($event)" },
        providers: [customValueAccessorFactory(SuiCheckboxValueAccessor_1)]
    }),
    __metadata("design:paramtypes", [SuiCheckbox])
], SuiCheckboxValueAccessor);
export { SuiCheckboxValueAccessor };
var SuiCheckboxValueAccessor_1;
//# sourceMappingURL=checkbox.js.map