import { Component, Directive, Input, Output, HostListener, HostBinding, EventEmitter, ViewChild, ElementRef } from "@angular/core";
import { customValueAccessorFactory, CustomValueAccessor } from "../../../misc/util";
var SuiRadioButton = (function () {
    function SuiRadioButton() {
        this._radioClasses = true;
        this.isChecked = false;
        this.currentValueChange = new EventEmitter();
        this.isDisabled = false;
        this.isReadonly = false;
        this._radioClasses = true;
    }
    Object.defineProperty(SuiRadioButton.prototype, "checkedAttribute", {
        get: function () {
            return this.isChecked ? "" : undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SuiRadioButton.prototype, "isDisabledAttribute", {
        get: function () {
            return this.isDisabled ? "disabled" : undefined;
        },
        enumerable: true,
        configurable: true
    });
    SuiRadioButton.prototype.onClick = function () {
        if (!this.isDisabled && !this.isReadonly) {
            this.currentValue = this.value;
            this.currentValueChange.emit(this.currentValue);
            this.update();
            this.focusRadio();
        }
    };
    SuiRadioButton.prototype.update = function () {
        this.isChecked = this.currentValue === this.value;
    };
    SuiRadioButton.prototype.writeValue = function (value) {
        this.currentValue = value;
        this.update();
    };
    SuiRadioButton.prototype.focusRadio = function () {
        this._radioElement.nativeElement.focus();
    };
    return SuiRadioButton;
}());
__decorate([
    HostBinding("class.ui"),
    HostBinding("class.radio"),
    HostBinding("class.checkbox"),
    __metadata("design:type", Boolean)
], SuiRadioButton.prototype, "_radioClasses", void 0);
__decorate([
    Input(),
    __metadata("design:type", String)
], SuiRadioButton.prototype, "name", void 0);
__decorate([
    Input(),
    __metadata("design:type", Object)
], SuiRadioButton.prototype, "value", void 0);
__decorate([
    HostBinding("class.checked"),
    __metadata("design:type", Boolean)
], SuiRadioButton.prototype, "isChecked", void 0);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter)
], SuiRadioButton.prototype, "currentValueChange", void 0);
__decorate([
    Input(),
    __metadata("design:type", Boolean)
], SuiRadioButton.prototype, "isDisabled", void 0);
__decorate([
    HostBinding("class.read-only"),
    Input(),
    __metadata("design:type", Boolean)
], SuiRadioButton.prototype, "isReadonly", void 0);
__decorate([
    ViewChild("radio"),
    __metadata("design:type", ElementRef)
], SuiRadioButton.prototype, "_radioElement", void 0);
__decorate([
    HostListener("click"),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], SuiRadioButton.prototype, "onClick", null);
SuiRadioButton = __decorate([
    Component({
        selector: "sui-radio-button[ngModel]",
        exportAs: "suiRadioButton",
        template: "\n<input class=\"hidden\"\n       type=\"checkbox\"\n       [attr.name]=\"name\"\n       [attr.checked]=\"checkedAttribute\"\n       [attr.disabled]=\"isDisabledAttribute\"\n       [ngModel]=\"isChecked\"\n       (ngModel)=\"currentValue = value\"\n       #radio>\n<label>\n    <ng-content></ng-content>\n</label>\n"
    }),
    __metadata("design:paramtypes", [])
], SuiRadioButton);
export { SuiRadioButton };
var SuiRadioButtonValueAccessor = SuiRadioButtonValueAccessor_1 = (function (_super) {
    __extends(SuiRadioButtonValueAccessor, _super);
    function SuiRadioButtonValueAccessor(host) {
        return _super.call(this, host) || this;
    }
    return SuiRadioButtonValueAccessor;
}(CustomValueAccessor));
SuiRadioButtonValueAccessor = SuiRadioButtonValueAccessor_1 = __decorate([
    Directive({
        selector: "sui-radio-button",
        host: { "(currentValueChange)": "onChange($event)" },
        providers: [customValueAccessorFactory(SuiRadioButtonValueAccessor_1)]
    }),
    __metadata("design:paramtypes", [SuiRadioButton])
], SuiRadioButtonValueAccessor);
export { SuiRadioButtonValueAccessor };
var SuiRadioButtonValueAccessor_1;
//# sourceMappingURL=radiobutton.js.map