// Used to pass ability to control a modal to a component.
var ModalControls = (function () {
    function ModalControls(approve, deny) {
        this.approve = approve;
        this.deny = deny;
    }
    // Use method here rather than arrow variables to make intellisense show they're methods.
    ModalControls.prototype.approve = function (result) { };
    ModalControls.prototype.deny = function (result) { };
    return ModalControls;
}());
export { ModalControls };
// Injected into custom modal components, to allow control of the modal, and access to a context object.
var Modal = (function (_super) {
    __extends(Modal, _super);
    function Modal(controls, context) {
        var _this = 
        // Instances of `ModalControls` are only created in the `SuiModal` constructor,
        // so we take an initialised instance rather than remaking one each time.
        _super.call(this, controls.approve, controls.deny) || this;
        _this.context = context;
        return _this;
    }
    return Modal;
}(ModalControls));
export { Modal };
//# sourceMappingURL=modal-controls.js.map