import { Component, Input, HostBinding, HostListener, EventEmitter, ViewContainerRef, ViewChild, Renderer2, ElementRef, Output } from "@angular/core";
import { SuiDropdownMenuItem } from "../../dropdown";
import { HandledEvent } from "../../../misc/util";
var SuiSelectOption = (function (_super) {
    __extends(SuiSelectOption, _super);
    function SuiSelectOption(renderer, element) {
        var _this = 
        // We inherit SuiDropdownMenuItem to automatically gain all keyboard navigation functionality.
        // This is not done via adding the .item class because it isn't supported by Angular.
        _super.call(this, renderer, element) || this;
        _this._optionClasses = true;
        _this.isActive = false;
        _this.onSelected = new EventEmitter();
        // By default we make this function return an empty string, for the brief moment when it isn't displaying the correct label.
        _this.formatter = function (o) { return ""; };
        _this.usesTemplate = false;
        return _this;
    }
    Object.defineProperty(SuiSelectOption.prototype, "formatter", {
        set: function (formatter) {
            if (!this.usesTemplate) {
                this.renderedText = formatter(this.value);
            }
            else {
                this.renderedText = undefined;
            }
        },
        enumerable: true,
        configurable: true
    });
    SuiSelectOption.prototype.onClick = function (e) {
        var _this = this;
        e.eventHandled = true;
        setTimeout(function () { return _this.onSelected.emit(_this.value); });
    };
    return SuiSelectOption;
}(SuiDropdownMenuItem));
__decorate([
    HostBinding("class.item"),
    __metadata("design:type", Boolean)
], SuiSelectOption.prototype, "_optionClasses", void 0);
__decorate([
    Input(),
    __metadata("design:type", Object)
], SuiSelectOption.prototype, "value", void 0);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter)
], SuiSelectOption.prototype, "onSelected", void 0);
__decorate([
    HostBinding("class.active"),
    __metadata("design:type", Boolean)
], SuiSelectOption.prototype, "isActive", void 0);
__decorate([
    ViewChild("templateSibling", { read: ViewContainerRef }),
    __metadata("design:type", ViewContainerRef)
], SuiSelectOption.prototype, "templateSibling", void 0);
__decorate([
    HostListener("click", ["$event"]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [HandledEvent]),
    __metadata("design:returntype", void 0)
], SuiSelectOption.prototype, "onClick", null);
SuiSelectOption = __decorate([
    Component({
        selector: "sui-select-option",
        template: "\n<span #templateSibling></span>\n<span [innerHTML]=\"renderedText\"></span>\n"
    }),
    __metadata("design:paramtypes", [Renderer2, ElementRef])
], SuiSelectOption);
export { SuiSelectOption };
//# sourceMappingURL=select-option.js.map